#!/usr/bin/perl
########################################################################
#
# $Id: ui_backup.pl,v 1.1 2015/10/14 16:35:41 gosha Exp $
#
#		(c) Okunev Igor <igor[at]prv.mts-nn.ru> 
#						2015
#
########################################################################
package VirtualPBX;

open STDERR, '>>/var/log/VirtualPBX/XVB.stderr';

use strict;

use lib qw( /opt/VirtualPBX/lib );

use XVB::Core;
use XVB::Database;
						
########################################################################
							main();
########################################################################


########################################################################
#
sub new {
	my ( $class, $config_file ) = @_;

	my $obj = bless { 	_CONF	=> {}, 
						_CDR	=> {
							CALLED_ID => 'cleaner',
							CALLER_ID => 'cleaner'
						},
						_DB => { PERSISTENT_CONNECTION => 1 } }, $class;

	$obj->core_cfg_init( $config_file );

	$obj->core_log_init();

	return $obj;
}

########################################################################
#
sub main {
	my $obj = new VirtualPBX( '/opt/VirtualPBX/etc/xvb.cfg' );

	my $path = $obj->core_cfg_get( 'PATH_UI_BACKUP_DIR' ) || return 0;

	my %bk_days = map { $_ => 1 } split( /\s*,\s*/, $obj->core_cfg_get( 'COMMON_UI_BACKUP_DAYS' ) );

	return 0 unless exists $bk_days{ (localtime)[6] };

	my $start_time = time;

	my $sql = 'select 
						a.VOICENUMBER,
						a.ACCESS_CODE,
						vb.PIN_CODE,
						vb.PIN_CODE2
				from 
					' . $obj->core_cfg_get( 'TABLES_ACCOUNT' ) . ' a,
					' . $obj->core_cfg_get( 'TABLES_VBOX_CORE' ) . ' vb,
					' . $obj->core_cfg_get( 'TABLES_GROUP' ) . ' g
				 where 
				 	vb.SUBSCR_ID = a.ID and
					a.GROUP_ID = g.GROUP_ID and
					g.SERVER_ID = ? and
					a.STATUS = 1 and
					vb.EXT_NUMBER = '. "'0'";

	my $accounts = $obj->db_get_array_hashref( $sql, $obj->core_cfg_get( 'COMMON_SERVER_ID' ) );

	return unless $accounts;

	my $counter = 0;
		
	foreach my $ref ( @{ $accounts } ) {
		my $fn = $path .'/'. substr($ref->{'ACCESS_CODE'},-3) .'/'. $ref->{'ACCESS_CODE'};
		system "mkdir -p $fn";
		$fn .= '/'. (localtime)[6] .'.tgz';
		unlink $fn;
		system "wget -q 'https://localhost/ui/backup?full_backup=1&phone=". $ref->{'ACCESS_CODE'} .'@'. $ref->{'VOICENUMBER'} .'&pw='. $ref->{'PIN_CODE'} . $ref->{'PIN_CODE2'} ."'". ' --no-check-certificate -O '. $fn;
		$counter++;
	}

	my $stop_time = time;

	$obj->core_log( 'UI backups, start: '. scalar(localtime($start_time)) .', stop: '. scalar(localtime($stop_time)) .", count: $counter" );
}

